# CClose
[![GitHub All Releases](https://img.shields.io/github/downloads/chaohershi/cclose/total)](https://github.com/chaohershi/cclose/releases/latest)
[![GitHub Repo stars](https://img.shields.io/github/stars/chaohershi/cclose)](https://github.com/chaohershi/cclose)

CClose is a Windows utility written in AutoHotkey. It helps you manipulate windows faster and easier. It also allows you to pin windows always-on-top.

![CClose Demo: Right click + taskbar button = move pointer to "Close window".](docs/assets/img/Demo_RC_MovePtr.gif) 
![CClose Demo: Hold left click + title bar = toggle window always on top.](docs/assets/img/Demo_HLC_Pin.gif)

## All Features

| Action          | + Target         | = Result                         |
| :-------------- | :--------------- | :------------------------------- |
| Middle click    | + title bar      | = close window                   |
| Right click     | + title bar      | = minimize window                |
| Hold left click | + title bar      | = toggle window always on top    |
| Double press    | + Esc key        | = close active window            |
| Right click     | + taskbar button | = move pointer to "Close window" |

## Download
You can download the installer `CClose Setup.exe` [here](https://github.com/chaohershi/cclose/releases/latest).

**Please be aware that you may get a popup message from Windows SmartScreen when running the installer.** The message would state that "Windows Defender SmartScreen prevented an unrecognized app from starting." This is totally normal. It takes some time for a new certificate, like the one that CClose is using, to get recognized. Nevertheless, CClose is free and minimal and contains no malware of any kind. Feel free to do a virus scan if you are worried!

To run CClose from Windows SmartScreen, click on the "More info" link and then click on the "Run anyway" button.  
![Run CClose from Windows SmartScreen: Click on the "More info" link and then click on the "Run anyway" button.](docs/assets/img/Run_CClose_from_Windows_Smartscreen.gif)

## Donate
Thank you for your support!

You may purchase the [Pro](https://chaohershi.github.io/cclose/) version to support the development of CClose. ❤

## License
CClose is available under the MIT License.  
CClose icon made by [Pavel Kozlov](https://www.flaticon.com/authors/pavel-kozlov) from [Flaticon](https://www.flaticon.com/free-icon/delete-button_70287) is licensed by [CC 3.0 BY](https://creativecommons.org/licenses/by/3.0/).
